package nl.iobyte.themepark.listener;

import nl.iobyte.themepark.ThemeParkPlugin;
import nl.iobyte.themepark.api.attraction.Region;
import nl.iobyte.themepark.api.events.region.ChangeDataEvent;
import nl.iobyte.themepark.api.events.region.ChangeLoreEvent;
import nl.iobyte.themepark.api.events.region.ChangeMaterialEvent;
import nl.iobyte.themepark.api.events.region.ChangeNameEvent;
import nl.iobyte.themepark.config.YamlConfig;
import nl.iobyte.themepark.database.DBManager;
import nl.iobyte.themepark.menu.AttractionMenu;
import nl.iobyte.workchain.components.Work;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import java.util.HashMap;

public class RegionListener implements Listener {

    @EventHandler
    public void onChange(ChangeNameEvent e) {
        AttractionMenu.updateRegion(e.getRegion());

        Region region = e.getRegion();
        YamlConfig config = ThemeParkPlugin.getInstance().getRegions();
        config.getConfig().set("regions." + region.getId() + ".name", e.getAfter());
        config.save();

        Work.firstTask(() -> DBManager.getDatabase("public")).abortIfNull().lastTask(database -> {
            HashMap<Integer, Object> obj = new HashMap<>();
            obj.put(1, e.getAfter());
            obj.put(2, region.getId());

            String query ="UPDATE region SET name=? WHERE id=?";
            database.execute(query, obj);
        }).execute();
    }

    @EventHandler
    public void onChange(ChangeLoreEvent e) {
        AttractionMenu.updateRegion(e.getRegion());

        Region region = e.getRegion();
        YamlConfig config = ThemeParkPlugin.getInstance().getRegions();
        config.getConfig().set("regions." + region.getId() + ".lore", e.getAfter());
        config.save();
    }

    @EventHandler
    public void onChange(ChangeMaterialEvent e) {
        AttractionMenu.updateRegion(e.getRegion());

        Region region = e.getRegion();
        YamlConfig config = ThemeParkPlugin.getInstance().getRegions();
        config.getConfig().set("regions." + region.getId() + ".material", e.getAfter().toString());
        config.save();
    }

    @EventHandler
    public void onChange(ChangeDataEvent e) {
        AttractionMenu.updateRegion(e.getRegion());

        Region region = e.getRegion();
        YamlConfig config = ThemeParkPlugin.getInstance().getRegions();
        config.getConfig().set("regions." + region.getId() + ".data", e.getAfter());
        config.save();
    }

}
