package nl.iobyte.themepark.util;

import net.md_5.bungee.api.ChatColor;
import net.md_5.bungee.api.chat.BaseComponent;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.TextComponent;
import nl.iobyte.themepark.ThemeParkPlugin;
import nl.iobyte.themepark.config.YamlConfig;

import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class MessageUtil {

    private static YamlConfig config = ThemeParkPlugin.getInstance().getMessages();

    public static boolean isMessage(String string) {
        return config.getConfig().contains(string);
    }

    public static String getMessage(String string) {
        if(!isMessage(string))
            return "";

        String message = config.getConfig().getString(string);
        if(isMessage("prefix"))
            message = message.replace("{prefix}", config.getConfig().getString("prefix"));

        return message;
    }

    public static BaseComponent parseTP(String string, HashMap<String, String> change, ClickEvent click, HoverEvent hover) {
        String message = getMessage(string);
        for(Map.Entry<String, String> entrySet : change.entrySet())
            message = message.replace(entrySet.getKey(), entrySet.getValue());

        message = Color.color(message);
        if(click != null) {
            String regex = "(.*)\\[TP\\](.*?)\\[/TP\\](.*)";
            Pattern p = Pattern.compile(regex);
            Matcher m = p.matcher(message);
            while (m.find()) {
                String first = m.group(1);
                String middle = m.group(2);
                String last = m.group(3);

                BaseComponent[] components = TextComponent.fromLegacyText(first);
                BaseComponent component = components[0];
                for(int i = 1; i < components.length; i++)
                    component.addExtra(components[i]);

                components = TextComponent.fromLegacyText(middle);
                BaseComponent compClick = components[0];
                for(int i = 1; i < components.length; i++)
                    compClick.addExtra(components[i]);

                compClick.setClickEvent(click);
                if(hover != null)
                    compClick.setHoverEvent(hover);

                component.addExtra(compClick);
                components = TextComponent.fromLegacyText(last);
                BaseComponent compLast = components[0];
                for (BaseComponent baseComponent : components) component.addExtra(baseComponent);

                component.addExtra(compLast);
                return component;
            }
        }

        BaseComponent[] components = TextComponent.fromLegacyText(message);
        BaseComponent component = components[0];
        for(int i = 1; i < components.length; i++)
            component.addExtra(components[i]);

        return component;
    }

}
